jQuery(document).ready(function($) {
	"use strict"; 
	
	var pageNum = parseInt(fnwp_.startPage) + 1;
	var max = parseInt(fnwp_.maxPages);
	var nextLink = fnwp_.nextLink;
	var readmore = fnwp_.readtext;
	var loading = fnwp_.loading;
	var nomoreposts = fnwp_.nomoreposts;
	var cssLink = fnwp_.cssLink;
	var style = fnwp_.style;
	
	if(pageNum <= max) {
		$('.blogrevolution-bp-load-more-'+ style +' .blogrevolution-bp-vc-element-blogs-article-container')
			.append('<div class="blogrevolution-bp-load-more-container blogrevolution-bp-placeholder-'+ pageNum +'-'+ style +'"></div><div class="clearfix"></div>')
			.append('<div id="blogrevolution-bp-load-blogs" class="blogrevolution-bp-load-blogs-'+ style +'"><a href="#" '+ cssLink +'>'+ readmore + '</a></div>');
	}
	
	$('.blogrevolution-bp-load-blogs-'+ style +' a').on( "click", function() {
		if(pageNum <= max) {		
			$(this).text(loading);			
			$('.blogrevolution-bp-placeholder-'+ pageNum +'-'+ style +'').load(nextLink + ' .blogrevolution-bp-item-load-more-'+ style +'',
				function() {
					pageNum++;
					nextLink = nextLink.replace(/\/page\/[0-9]?/, '/page/'+ pageNum);
					$('.blogrevolution-bp-load-blogs-'+ style +'')
						.before('<div class="blogrevolution-bp-load-more-container blogrevolution-bp-placeholder-'+ pageNum +'-'+ style +'"></div><div class="clearfix"></div>')
					if(pageNum <= max) {
						$('.blogrevolution-bp-load-blogs-'+ style +' a').text(readmore);
					} else {
						$('.blogrevolution-bp-load-blogs-'+ style +' a').text(nomoreposts);
					}
				}
			);
		} else {
			$('.blogrevolution-bp-load-blogs-style1 a').append('.');
		}	
		
		return false;
	});
	
});