<?php
/*
Addon: TEAMVISION Functions
*/
function box_position($settings, $id){

	$position_title       	 = esc_html($settings['position_title']);
	$position_img         	 = esc_html($settings['position_img']);
	$position_content     	 = esc_html($settings['position_content']);
	$position_info        	 = esc_html($settings['position_info']);
	$position_category    	 = esc_html($settings['position_category']);

	$show_title          		 = esc_html($settings['show_title']);
	$show_img             	 = esc_html($settings['show_img']);
	$show_content         	 = esc_html($settings['show_content']);
	$show_info          		 = esc_html($settings['show_info']);
	$show_author          	 = esc_html($settings['show_author']);
	$show_date          		 = esc_html($settings['show_date']);
	$show_comment         	 = esc_html($settings['show_comment']);
	$show_category    			 = esc_html($settings['show_category']);
	$number_excerpt					 = esc_html($settings['number_excerpt']);
  $columns              	 = esc_html($settings['columns']);

	// Style
	$title_color						 = esc_html($settings['title_color']);
	$text_color							 = esc_html($settings['text_color']);
	$category_info_color		 = esc_html($settings['category_info_color']);
	$hover_color						 = esc_html($settings['hover_color']);


  $general_positions = array(1,2,3,4,5);

  foreach($general_positions as $general_position) {

			/**TITILE SECTION**/
			if($position_title == $general_position && $show_title == 'yes') { echo '<h1 class="title_post"> <a  style="color: ' . $settings['title_color'] . '"
			  onMouseOver="this.style.color = \''.esc_html($settings['hover_color']).'\';" onMouseLeave="this.style.color = \''.esc_html($settings['title_color']).'\';"
				href="'.get_permalink().'">'.get_the_title().'</a></h1>';}
			/**END TITILE SECTION**/

			/**IMG SECTION**/
			if($position_img == $general_position && $show_img == 'yes') {
				echo blogrevolution_get_blogs_thumb($columns,$id);
			}
			/**END IMG SECTION**/

			/**CONTENT SECTION**/
			if($position_content == $general_position && $show_content == 'yes') {
					if(!is_numeric($number_excerpt)){
						$number_excerpt=200;
					}
					echo '<p class="text_post" style="color: '. $settings['text_color'] .' ">';
							$excerpt = get_the_excerpt();
							$excerpt = substr($excerpt, 0, $number_excerpt);
							$result = substr($excerpt, 0, strrpos($excerpt, ' '));
							echo $result;
					echo blogrevolution_loadmore($settings['text_color'], $hover_color) . '</p>';
			}
			/**END CONTENT SECTION**/

			/**INFO SECTION**/
			if($position_info == $general_position && $show_info == 'yes') {
						echo '<div class="box_info line">';
							if($show_author == 'yes') { echo '<div class="info post_author"><i style="color: '. $settings['category_info_color'] .' " class="far fa-user"></i>'.blogrevolution_get_author($settings['category_info_color'], $hover_color).'</div>'; }
							if($show_date == 'yes') { echo '<div style="color: '. $settings['category_info_color'] .' " class="info post_date"><i style="color: '. $settings['category_info_color'] .' "  class="far fa-calendar-alt"></i>'.get_the_date().'</div>'; }
							if($show_comment == 'yes') { echo '<div class="info post_comment"><i style="color: '. $settings['category_info_color'] .' "  class="far fa-comment-alt"></i>'.blogrevolution_comments_function($id,$settings['category_info_color'], $hover_color).'</div>'; }
						echo'</div>';
			}
			/**END INFO SECTION**/

			/**CATEGORY SECTION**/
		  if($position_category == $general_position && $show_category == 'yes') { echo '<h4 class="info post_category line">'.blogrevolution_category_function($settings['category_info_color'], $hover_color).'</h4>'; }
			/**END CATEGORY SECTION**/


  }/*END FOREACH*/

}/*END FUNCTION BOX_POSITIONS*/

/**load More**/
if(!function_exists('blogrevolution_loadmore')) {
		function blogrevolution_loadmore($colorloadmore, $hover_color){
			$output = '<a href="'.get_permalink().'" class="load_more"><i style="color:'. $colorloadmore.' " class="fas fa-long-arrow-alt-right"

			onMouseOver="this.style.color = \''.esc_html($hover_color).'\';" onMouseLeave="this.style.color = \''.esc_html($colorloadmore).'\';"

			></i></a>';
			return $output;
		}
}

/** Get Author **/
if(!function_exists('blogrevolution_get_author')) {
	function blogrevolution_get_author($color_category_info, $hover_color) {
		$return = '<a href="'.get_author_posts_url( get_the_author_meta( 'ID' ) ).'" style="color:'.$color_category_info.'"

		onMouseOver="this.style.color = \''.esc_html($hover_color).'\';" onMouseLeave="this.style.color = \''.esc_html($color_category_info).'\';"

		>'.get_the_author_meta( 'display_name' ).'</a>';
		return $return;
	}
}


if(!function_exists('blogrevolution_category_function')) {
		function blogrevolution_category_function($color_category, $hover_color){
			$output = '';
			$categories = get_the_category();
				if ($categories) {
					foreach($categories as $category) {
						$output .= '<a style="color: '. $color_category .' " href="'.get_category_link( $category->term_id ).'"

						onMouseOver="this.style.color = \''.esc_html($hover_color).'\';" onMouseLeave="this.style.color = \''.esc_html($color_category).'\';"

						>'.esc_html($category->cat_name).'</a>';
					}
				}
			return $output;
		}
}


if(!function_exists('blogrevolution_comments_function')) {
	function blogrevolution_comments_function($id,$color_comment, $hover_color) {
			$args_comments = array(
					'post_id' => $id,   // Use post_id, not post_ID
					'count'   => true // Return only the count
			);
			$comments_count = get_comments( $args_comments );
			return '<a style="color: '. $color_comment .' " href="' . get_comments_link() .'"

			onMouseOver="this.style.color = \''.esc_html($hover_color).'\';" onMouseLeave="this.style.color = \''.esc_html($color_comment).'\';"

			>'.$comments_count.'</a>';
	}
}


/** Get Animations **/
if(!function_exists('blogrevolution_animate_class')) {
	function blogrevolution_animate_class($addon_animate,$effect,$delay) {
		if($addon_animate == 'on') :
			wp_enqueue_script( 'appear' );
			wp_enqueue_script( 'animate' );
			$animate_class = ' animate-in" data-anim-type="'.$effect.'" data-anim-delay="'.$delay.'"';
		else :
			$animate_class = '"';
		endif;
		return $animate_class;
	}
}

/** Get Category **/
if(!function_exists('blogrevolution_get_category')) {
	function blogrevolution_get_category($source,$posts_type,$css_link,$limit = 1) {
		$separator = ' ';
		$output = '';
		$count = 1;
		if($source=='wp_posts') {
			$categories = get_the_category();
			if($categories){
				foreach($categories as $category) {
					$output .= '<a href="'.get_category_link( $category->term_id ).'" title="' . esc_attr( sprintf( __( "View all posts in %s",'blogrevolutionelementor' ), $category->name ) ) . '" '.$css_link.'>'.esc_html($category->cat_name).'</a>'.esc_html($separator);
					if($count == $limit) { break; }
					$count++;
				}
			}
		} elseif($source=='post_type') {
			global $post;
			$taxonomy_names = get_object_taxonomies( $posts_type );
			$term_list = wp_get_post_terms($post->ID,$taxonomy_names);
			if($term_list){
				foreach ($term_list as $tax_term) {
					$output .= '<a href="' . esc_attr(get_term_link($tax_term, $posts_type)) . '" title="' . sprintf( __( "View all posts in %s",'blogrevolutionelementor' ), $tax_term->name ) . '" '.$css_link.'>' . esc_html($tax_term->name) .'</a>'.esc_html($separator);
				}
			}
		}
		$return = trim($output, $separator);
		return $return;
	}
}



/** Get Comments **/
if(!function_exists('blogrevolution_get_num_comments')) {
	function blogrevolution_get_num_comments($css_comment,$css_comment_link) {
			$num_comments = get_comments_number();

			if ( $num_comments == 0 ) {
					$comments = esc_html__('No Comments','blogrevolutionelementor');
					$return = $comments;
			} elseif ( $num_comments > 1 ) {
					$comments = $num_comments . esc_html__(' Comments','blogrevolutionelementor');
					$return = '<a href="' . get_comments_link() .'" '.$css_comment_link.'>'. esc_html($comments).'</a>';
			} else {
					$comments = esc_html__('1 Comment','blogrevolutionelementor');
					$return = '<a href="' . get_comments_link() .'" '.$css_comment_link.'>'. esc_html($comments) .'</a>';
			}
			return $return;
	}
}

if(!function_exists('blogrevolution_get_only_num_comments')) {
	function blogrevolution_get_only_num_comments($css_comment,$css_comment_link) {
			$num_comments = get_comments_number();

			if ( $num_comments == 0 ) {
					$return = '<span '.$css_comment.'>'.esc_html($num_comments).'</span>';
			} elseif ( $num_comments > 1 ) {
					$return = '<a href="' . get_comments_link() .'" '.$css_comment_link.'>'. esc_html($num_comments).'</a>';
			} else {
					$return = '<a href="' . get_comments_link() .'" '.$css_comment_link.'>'. esc_html($num_comments).'</a>';
			}
			return $return;
	}
}

/** Get Thumbnails **/
if(!function_exists('blogrevolution_get_thumb')) {
	function blogrevolution_get_thumb($thumbs_size = 'blogrevolution-normal') {
		global $post;
		$link = get_the_permalink();
		if(has_post_thumbnail()){
				$id_post = get_the_id();
				$single_image = wp_get_attachment_image_src( get_post_thumbnail_id($id_post), $thumbs_size );
				$image_alt = get_post_meta( get_post_thumbnail_id($id_post), '_wp_attachment_image_alt', true);
				$return = '<a  class="img_post" href="'.$link.'"><img class="blogrevolution-thumbs" src="'.$single_image[0].'" alt="'.$image_alt.'"></a>';
			} else {
				$return = '';
		}
		return $return;
	}
}

/** Get Blog Thumbnails **/
if(!function_exists('blogrevolution_get_blogs_thumb')) {
	function blogrevolution_get_blogs_thumb($columns,$post_id) {
		global $post;
		if($columns == '1') :
			$return = blogrevolution_get_thumb('blogrevolution-large');
		elseif($columns == '2') :
			$return = blogrevolution_get_thumb('blogrevolution-normal');
		else :
			$return = blogrevolution_get_thumb('blogrevolution-normal');
		endif;
		return $return;
	}
}


/** Get Blog Excerpt **/
if(!function_exists('blogrevolution_get_blogs_excerpt')) {
	function blogrevolution_get_blogs_excerpt($excerpt = 'default',$readmore = 'on',$css_link = '') {
		global $post;
		if($excerpt == 'default') :
			$return = get_the_excerpt();
		else :
			$return = substr(get_the_excerpt(), 0, $excerpt);
			if($readmore == 'on') :
				$return .= '<a class="article-read-more" href="'. get_permalink($post->ID) . '" '.$css_link.'>'.esc_html__('Read More','blogrevolutionelementor').'</a>';
			else :
				$return .= '...';
			endif;
		endif;
		return $return;
	}
}

/** Get News Excerpt **/
if(!function_exists('blogrevolution_get_news_excerpt')) {
	function blogrevolution_get_news_excerpt($excerpt = 'default',$readmore = 'on',$css_link) {
		global $post;
		if($excerpt == 'default') :
			$return = get_the_excerpt();
		else :
			$return = substr(get_the_excerpt(), 0, $excerpt);
			if($readmore == 'on') :
				$return .= '<a class="article-read-more" href="'. get_permalink($post->ID) . '" '.$css_link.'><i class="fa fa-angle-double-right"></i></a>';
			else :
				$return .= '...';
			endif;
		endif;
		return $return;
	}
}

/** Get News Excerpt **/
if(!function_exists('blogrevolution_get_news_v2_excerpt')) {
	function blogrevolution_get_news_v2_excerpt($excerpt = 'default',$readmore = 'on',$css_link) {
		global $post;
		if($excerpt == 'default') :
			$return = get_the_excerpt();
		else :
			$return = substr(get_the_excerpt(), 0, $excerpt);
			if($readmore == 'on') :
				$return .= '<a class="article-read-more" href="'. get_permalink($post->ID) . '" '.$css_link.'>...</a>';
			else :
				$return .= '...';
			endif;
		endif;
		return $return;
	}
}

/** Check Post Format **/
if(!function_exists('blogrevolution_check_post_format')) {
	function blogrevolution_check_post_format() {
		global $post;
		$format = get_post_format_string( get_post_format() );
		if($format == 'Video') :
			$return = '<span class="blogrevolution-format-type fa fa-play-circle-o"></span>';
		elseif($format == 'Audio') :
			$return = '<span class="blogrevolution-format-type fa fa-headphones"></span>';
		else :
			$return = '';
		endif;
		return $return;
	}
}

/** Get Numeric Pagination **/
if(!function_exists('blogrevolution_posts_numeric_pagination')) {
	function blogrevolution_posts_numeric_pagination($pages = '', $range = 2,$loop,$paged,$css_current_pag_num,$css_link) {
		 $showitems = ($range * 2)+1;

		 if(empty($paged)) $paged = 1;

		 if($pages == '')
		 {
			 $pages = $loop->max_num_pages;
			 if(!$pages)
			 {
				 $pages = 1;
			 }
		 }

		 $return = '';

		 if(1 != $pages) {
			 $return .= "<div class='fnwp-numeric-pagination'>";
			 if($paged > 2 && $paged > $range+1 && $showitems < $pages) $return .=  "<a href='".get_pagenum_link(1)."' class=\"fnwp-pagination-numeric-arrow\" ".$css_link."><i class=\"fa fa-angle-double-left fnwp-icon-double-left\"></i></a>";
			 if($paged > 1 && $showitems < $pages) $return .=  "<a href='".get_pagenum_link($paged - 1)."' class=\"fnwp-pagination-numeric-arrow\" ".$css_link."><i class=\"fa fa-angle-left fnwp-icon-left\"></i></a>";

			 for ($i=1; $i <= $pages; $i++)
			 {
				 if (1 != $pages &&( !($i >= $paged+$range+1 || $i <= $paged-$range-1) || $pages <= $showitems ))
				 {
					 $return .=  ($paged == $i)? "<span class='current' ".$css_current_pag_num.">".$i."</span>":"<a href='".get_pagenum_link($i)."' class='inactive' ".$css_link.">".$i."</a>";
				 }
			 }

			 if ($paged < $pages && $showitems < $pages) $return .= "<a href='".get_pagenum_link($paged + 1)."' class=\"fnwp-pagination-numeric-arrow\" ".$css_link."><i class=\"fa fa-angle-right fnwp-icon-right\"></i></a>";
			 if ($paged < $pages-1 &&  $paged+$range-1 < $pages && $showitems < $pages) $return .=  "<a href='".get_pagenum_link($pages)."' class=\"fnwp-pagination-numeric-arrow\" ".$css_link."><i class=\"fa fa-angle-double-right fnwp-icon-double-right\"></i></a>";
			 $return .=  "</div>\n";
		 }

		 return $return;
	}
}

/* Gallery Pagination */
function blogrevolution_get_gallery_pagination($num_page_for_pagination,$pagination) {
	$output = '<ul class="blogrevolution_gallery_pagination">';
	for($i=1; $i <= $num_page_for_pagination; $i++) {

		if($i == $pagination) {
			$output .= '<li class="mg_current">'.esc_html($i).'</li>'; // CURRENT PAGE
		} else {
			$output .= '<li><a href="'.get_post_permalink().'&mg_page='.$i.'">'.esc_html($i).'</a></li>'; // OTHER PAGE
		}
	}
	$output .= '</ul>';
	return $output;
}

/* Var Gallery Pagination */
function blogrevolution_add_query_vars_blogrevolution_gallery_pagination( $vars ){
  $vars[] = "mg_page";
  return $vars;
}
add_filter( 'query_vars', 'blogrevolution_add_query_vars_blogrevolution_gallery_pagination' );

if(!function_exists('blogrevolution_query')) {
	function blogrevolution_query( $source,
						$posts_source,
						$posts_type,
						$categories,
						$categories_post_type,
						$order,
						$orderby,
						$pagination,
						$pagination_type,
						$num_posts,
						$num_posts_page) {

						if($orderby == 'views') {
								$orderby = 'meta_value_num';
								$view_order = 'views';
						} else { $view_order = ''; }

						if($source == 'post_type') {
							$posts_source = 'all_posts';
						}

						if($posts_source == 'all_posts') {

							$query = 'post_type=Post&post_status=publish&ignore_sticky_posts=1&orderby='.$orderby.'&order='.$order.'';

							// CUSTOM POST TYPE
							if($source == 'post_type') {
								$query .= '&post_type='.$posts_type.'';
							}

							if($view_order == 'views') {
								$query .= '&meta_key=wpb_post_views_count';
							}

							// CATEGORIES POST TYPE
							if($categories_post_type != '' && !empty($categories_post_type) && $source == 'post_type') {
								$taxonomy_names = get_object_taxonomies( $posts_type );
								$query .= '&'.$taxonomy_names[0].'='.$categories_post_type.'';
							}

							// CATEGORIES POSTS
							if($categories != '' && $categories != 'all' && !empty($categories) && $source == 'wp_posts') {
								$query .= '&category_name='.$categories.'';
							}

							if($pagination == 'yes' || $pagination == 'load-more') {
								$query .= '&posts_per_page='.$num_posts_page.'';
							} else {
								if($num_posts == '') { $num_posts = '-1'; }
								$query .= '&posts_per_page='.$num_posts.'';
							}

							// PAGINATION
							if($pagination == 'yes' || $pagination == 'load-more') {
								if ( get_query_var('paged') ) {
									$paged = get_query_var('paged');

								} elseif ( get_query_var('page') ) {
									$paged = get_query_var('page');
								} else {
									$paged = 1;
								}
								$query .= '&paged='.$paged.'';
							}
							// #PAGINATION

						} else { // IF STICKY


							if($pagination == 'yes' || $pagination == 'load-more') {
								$num_posts = $num_posts_page;
							} else {
								if($num_posts == '') { $num_posts = '-1'; }
								$num_posts = $num_posts;
							}

							// PAGINATION

							if ( get_query_var('paged') ) {
								$paged = get_query_var('paged');
							} elseif ( get_query_var('page') ) {
								$paged = get_query_var('page');
							} else {
								$paged = 1;
							}

							// #PAGINATION

							/* STICKY POST DA FARE ARRAY PER SCRITTURA IN ARRAY */

							$sticky = get_option( 'sticky_posts' );
							$sticky = array_slice( $sticky, 0, 5 );
							if($view_order == 'views') {
								$query = array(
									'post_type' => 'post',
									'post_status' => 'publish',
									'orderby' 	=> $orderby,
									'order' => $order,
									'category_name' => $categories,
									'posts_per_page' => $num_posts,
									'meta_key' => 'wpb_post_views_count',
									'paged' => $paged,
									'post__in'  => $sticky,
									'ignore_sticky_posts' => 1
								);
							} else {
								$query = array(
									'post_type' => 'post',
									'post_status' => 'publish',
									'orderby' 	=> $orderby,
									'order' => $order,
									'category_name' => $categories,
									'posts_per_page' => $num_posts,
									'paged' => $paged,
									'post__in'  => $sticky,
									'ignore_sticky_posts' => 1
								);
							}

						} // #all_posts

						return $query;
	}
}
